//****************************************************************
// Klotski Optimal Solver V1.0 by takaken
//****************************************************************
//       FALSE	  0	// CELLs
//       TRUE	  1	// I
#define  SOLVED	  2	// 𔭌
#define  CANCEL   3	// T~

#define  HASH_SIZE   2000003
#define  QUEUE_SIZE  1600000

typedef unsigned int u32;	// hashlp

// e̐ƋL^Jnʒu
int C1N, C2N, C3N, C4N;			// 
int C1S, C2S, C3S, C4S, C4E;	// list[]̊Jnʒu

// [`
int  Rule1;		// 0[P}Ẍړ] 1[Aړ]
int  Rule2;		// 0[Ȃ] 1[]

// TpՖ
int  BOARD[34] = {
	99, 99, 99, 99, 99,
	 0,  0,  0,  0, 99,
	 0,  0,  0,  0, 99,
	 0,  0,  0,  0, 99,
	 0,  0,  0,  0, 99,
	 0,  0,  0,  0, 99,
	99, 99, 99, 99
};

// BOARD[]̍W
int  INSIDE[20] = {
	 5,  6,  7,  8,
	10, 11, 12, 13,
	15, 16, 17, 18,
	20, 21, 22, 23,
	25, 26, 27, 28
};

// nbV\\
typedef struct hash {
	char list[15];		// {[h̏
	char hold;			// ێʒu
	int  steps;			// 萔
	struct hash* prev;	// e|C^
	struct hash* next;	// |C^()
} cell;
cell* BUCKET;
int  BucketCnt;

// DTpL[
cell*** QUEUE;
int  Qhead[2], Qtail[2];
int  QIN, QOUT;

// Jn|C^
cell* StartPtr;

// 𔭌|C^
cell* FindPtr;
int  MinSteps;

// ړ
char Stack0[20], Stack1[20];
int  IDX;

// WindowsŐp(T~)
int  ThreadBreak;

//****************************************************************
// [
//****************************************************************
// [m
int  MemAlloc(void)
{
	BUCKET = (cell*)malloc(sizeof(cell) * HASH_SIZE);
	if (!BUCKET) return FALSE;
	QUEUE = (cell***)malloc(sizeof(cell**) * 2);
	if (!QUEUE) {
		free(BUCKET);
		return FALSE;
	}
	QUEUE[0] = (cell**)malloc(sizeof(cell*) * QUEUE_SIZE);
	if (!QUEUE[0]) {
		free(QUEUE);
		free(BUCKET);
		return FALSE;
	}
	QUEUE[1] = (cell**)malloc(sizeof(cell*) * QUEUE_SIZE);
	if (!QUEUE[1]) {
		free(QUEUE[0]);
		free(QUEUE);
		free(BUCKET);
		return FALSE;
	}
	return TRUE;
}
// [
void MemFree(void)
{
	free(QUEUE[1]);
	free(QUEUE[0]);
	free(QUEUE);
	free(BUCKET);
}
//****************************************************************
// list[]  board[] 𕜌
//****************************************************************
void ListToBoard(int board[], char list[])
{
	int  i;

	for (i = 0; i < 20; i++)
		board[INSIDE[i]] = 0;
	for (i = C1S; i < C2S; i++) {
		board[list[i]] = 10;
	}
	for (i = C2S; i < C3S; i++) {
		board[list[i]] = 20;
		board[list[i] + 5] = 21;
	}
	for (i = C3S; i < C4S; i++) {
		board[list[i]] = 30;
		board[list[i] + 1] = 31;
	}
	for (i = C4S; i < C4E; i++) {
		board[list[i]] = 40;
		board[list[i] + 1] = 41;
		board[list[i] + 5] = 42;
		board[list[i] + 6] = 43;
	}
}
//****************************************************************
// g[Xf[^쐬
//****************************************************************
// ړ̈ʒu𒲂ׂ
int  TraceSub(int board0[], int board1[], int pos1)
{
	int  pos0;

	switch (board1[pos1]) {
	case 10:
		pos0 = pos1 - 5;
		if (board0[pos0] == 10 && board1[pos0] == 0) return pos0;
		pos0 = pos1 + 5;
		if (board0[pos0] == 10 && board1[pos0] == 0) return pos0;
		pos0 = pos1 - 1;
		if (board0[pos0] == 10 && board1[pos0] == 0) return pos0;
		pos0 = pos1 + 1;
		if (board0[pos0] == 10 && board1[pos0] == 0) return pos0;
		break;
	case 20:
		pos0 = pos1 - 5;
		if (board0[pos0] == 20 && board1[pos0] == 0) return pos0;
		pos0 = pos1 + 5;
		if (board0[pos0] == 20 && board1[pos0 + 5] == 0) return pos0;
		pos0 = pos1 - 1;
		if (board0[pos0] == 20 && board1[pos0] == 0) return pos0;
		pos0 = pos1 + 1;
		if (board0[pos0] == 20 && board1[pos0] == 0) return pos0;
		break;
	case 30:
		pos0 = pos1 - 5;
		if (board0[pos0] == 30 && board1[pos0] == 0) return pos0;
		pos0 = pos1 + 5;
		if (board0[pos0] == 30 && board1[pos0] == 0) return pos0;
		pos0 = pos1 - 1;
		if (board0[pos0] == 30 && board1[pos0] == 0) return pos0;
		pos0 = pos1 + 1;
		if (board0[pos0] == 30 && board1[pos0 + 1] == 0) return pos0;
		break;
	case 40:
		pos0 = pos1 - 5;
		if (board0[pos0] == 40 && board1[pos0] == 0) return pos0;
		pos0 = pos1 + 5;
		if (board0[pos0] == 40 && board1[pos0 + 5] == 0) return pos0;
		pos0 = pos1 - 1;
		if (board0[pos0] == 40 && board1[pos0] == 0) return pos0;
		pos0 = pos1 + 1;
		if (board0[pos0] == 40 && board1[pos0 + 1] == 0) return pos0;
		break;
	}
	return 0;
}
// 菇 BUCKET[] ɋL^
void Trace(cell* ptr0, cell* ptr1, int board1[], int pos1)
{
	int  board0[34], pos0;

	// ptr̔Ֆʂboard0[]ɕ
	ListToBoard(board0, &(ptr0->list[0]));

	// eՖʂΐeՖʂ֍ċAĂяo
	if (ptr0->prev)
		Trace(ptr0->prev, ptr0, board0, ptr0->hold);

	// 𓚂̎|C^
	ptr0->next = ptr1;

	// ړ(pos0)ƈړ(pos1)
	if (pos1 == 0) {	// ̔Ֆʂ
		ptr0->hold = 0;		// ړ (ڗp)
		ptr0->steps = 0;	// ړ (ڗp)
	}
	else {
		pos0 = TraceSub(board0, board1, pos1);	// pos1ւ̈ړ𒲂ׂ
		ptr0->hold = pos0;	// ړ (ڗp)
		ptr0->steps = pos1;	// ړ (ڗp)
	}
}
//****************************************************************
// BOARD[]̋L^
//****************************************************************
int  Write(int plus, int hold, cell* rptr)
{
	int  i, c1, c2, c3, c4, pos, steps, list[15];
	u32  hash, hash1, hash2, hash3, hash4;
	cell* wptr;

	// ̔Ֆʂ̎萔
	steps = rptr ? rptr->steps + plus : 0;

	// BOARD[] -> list[]
	c1 = c2 = c3 = c4 = 0;
	for (i = 0; i < 20; i++) {
		pos = INSIDE[i];
		switch (BOARD[pos]) {
		case 10: list[C1S + c1++] = pos; break;
		case 20: list[C2S + c2++] = pos; break;
		case 30: list[C3S + c3++] = pos; break;
		case 40: list[C4S + c4++] = pos; break;
		}
	}

	// list[] -> hashl
	hash1 = hash2 = hash3 = hash4 = 1;
	for (i = C1S; i < C2S; i++) hash1 *= (u32)list[i];
	for (i = C2S; i < C3S; i++) hash2 *= (u32)list[i];
	for (i = C3S; i < C4S; i++) hash3 *= (u32)list[i];
	for (i = C4S; i < C4E; i++) hash4 *= (u32)list[i];
	hash = (hash1 + hash2 + hash3 + hash4) % HASH_SIZE;

	// hashl -> o^|C^(wptr)
	for (;;) {
		wptr = &BUCKET[hash];
		if (wptr->steps == -1) break;	// CELL
		for (i = 0; i < C4E; i++)
			if (wptr->list[i] != list[i]) break;
		if (i == C4E) {	// Ֆ
			if (Rule1 == 0 || wptr->hold == 0) return TRUE;
			if (wptr->hold == hold) {	// ێʒu
				if (wptr->steps <= steps) return TRUE;	// 萔(orZ)
			}
		}
		hash = (hash + 491) % HASH_SIZE;	// ănbV
	}

	// Write BUCKET[]
	if (BucketCnt >= QUEUE_SIZE) return FALSE;	// CELLs
	for (i = 0; i < C4E; i++)
		wptr->list[i] = list[i];
	wptr->hold = hold;
	wptr->steps = steps;
	wptr->prev = rptr;
	BucketCnt++;

	// 𔭌?
	if (BOARD[21] == 40) {
		if (!FindPtr || FindPtr->steps > steps) {
			FindPtr = wptr;
			MinSteps = steps;
		}
		return TRUE;
	}

	// Write QUEUE[][]
	if (plus == 0) {
		QUEUE[QIN][Qtail[QIN]++] = wptr;
	}
	else {
		QUEUE[QOUT][Qtail[QOUT]++] = wptr;
	}

	return TRUE;	// VKo^
}
//****************************************************************
// E߂ s
//****************************************************************
//  (X^bNɋL^)
int  Push(int pos0, int len, int diff)
{
	int  idx = IDX;				// OIDX
	int  pos1 = pos0 + diff;	// ړ

	Stack0[IDX] = pos0;
	Stack1[IDX] = pos1;
	IDX++;
	BOARD[pos1] = BOARD[pos0];
	if (len == 2) {
		pos0 -= diff;
		pos1 -= diff;
		Stack0[IDX] = pos0;
		Stack1[IDX] = pos1;
		IDX++;
		BOARD[pos1] = BOARD[pos0];
	}
	BOARD[pos0] = 0;

	return idx;
}
// ߂ (IDX  idx ܂)
void Back(int idx)
{
	int  pos0, pos1;

	while (idx < IDX) {
		IDX--;
		pos0 = Stack0[IDX];
		pos1 = Stack1[IDX];
		BOARD[pos0] = BOARD[pos1];
		BOARD[pos1] = 0;
	}
}
//****************************************************************
// ɉ (len = ̈ړ, push = 0:̂ 1:)
//****************************************************************
int  PushU2(int pos0, int len, int  push);
// P}Xŏɉ
int  PushU1(int pos0, int len, int  push)
{
	int ok, pos1 = pos0 - 5;

	if (Rule2 == 0) {	// ̋Ȃ
		ok = BOARD[pos1] ? FALSE : TRUE;
	}
	else {				// ̋
		ok = FALSE;
		switch (BOARD[pos1]) {
		case  0: ok = TRUE; break;
		case 10: ok = PushU1(pos1, 1, push); break;
		case 21: ok = PushU1(pos1 - 5, 2, push); break;
		case 30: ok = PushU2(pos1, 1, push); break;
		case 31: ok = PushU2(pos1 - 1, 1, push); break;
		case 42: ok = PushU2(pos1 - 5, 2, push); break;
		case 43: ok = PushU2(pos1 - 6, 2, push); break;
		}
	}
	if (!ok) return FALSE;

	// ۂɉ
	if (push) Push(pos0, len, -5);

	return TRUE;
}
// Q}Xŏɉ
int  PushU2(int pos0, int len, int  push)
{
	int  pos1 = pos0 - 5;

	if (!push) {	// ̂
		if (!PushU1(pos0, len, push)) return FALSE;
		if (!PushU1(pos0 + 1, len, push)) return FALSE;
	}
	else {	// ۂɉ
		PushU1(pos0, len, push);
		PushU1(pos0 + 1, len, push);
	}

	return TRUE;
}
//****************************************************************
// ɉ (len = ̈ړ, push = 0:̂ 1:)
//****************************************************************
int  PushD2(int pos0, int len, int  push);
// P}Xŉɉ
int  PushD1(int pos0, int len, int  push)
{
	int ok, pos1 = pos0 + 5;

	if (Rule2 == 0) {	// ̋Ȃ
		ok = BOARD[pos1] ? FALSE : TRUE;
	}
	else {				// ̋
		ok = FALSE;
		switch (BOARD[pos1]) {
		case  0: ok = TRUE; break;
		case 10: ok = PushD1(pos1, 1, push); break;
		case 20: ok = PushD1(pos1 + 5, 2, push); break;
		case 30: ok = PushD2(pos1, 1, push); break;
		case 31: ok = PushD2(pos1 - 1, 1, push); break;
		case 40: ok = PushD2(pos1 + 5, 2, push); break;
		case 41: ok = PushD2(pos1 + 4, 2, push); break;
		}
	}
	if (!ok) return FALSE;

	// ۂɉ
	if (push) Push(pos0, len, 5);

	return TRUE;
}
// Q}Xŉɉ
int  PushD2(int pos0, int len, int  push)
{
	int  pos1 = pos0 + 5;

	if (!push) {	// ̂
		if (!PushD1(pos0, len, push)) return FALSE;
		if (!PushD1(pos0 + 1, len, push)) return FALSE;
	}
	else {	// ۂɉ
		PushD1(pos0, len, push);
		PushD1(pos0 + 1, len, push);
	}

	return TRUE;
}
//****************************************************************
// ɉ (len = ̈ړ, push = 0:̂ 1:)
//****************************************************************
int  PushL2(int pos0, int len, int  push);
// P}Xōɉ
int  PushL1(int pos0, int len, int  push)
{
	int ok, pos1 = pos0 - 1;

	if (Rule2 == 0) {	// ̋Ȃ
		ok = BOARD[pos1] ? FALSE : TRUE;
	}
	else {				// ̋
		ok = FALSE;
		switch (BOARD[pos1]) {
		case  0: ok = TRUE; break;
		case 10: ok = PushL1(pos1, 1, push); break;
		case 20: ok = PushL2(pos1, 1, push); break;
		case 21: ok = PushL2(pos1 - 5, 1, push); break;
		case 31: ok = PushL1(pos1 - 1, 2, push); break;
		case 41: ok = PushL2(pos1 - 1, 2, push); break;
		case 43: ok = PushL2(pos1 - 6, 2, push); break;
		}
	}
	if (!ok) return FALSE;

	// ۂɉ
	if (push) Push(pos0, len, -1);

	return TRUE;
}
// Q}Xōɉ
int  PushL2(int pos0, int len, int  push)
{
	int  pos1 = pos0 - 1;

	if (!push) {	// ̂
		if (!PushL1(pos0, len, push)) return FALSE;
		if (!PushL1(pos0 + 5, len, push)) return FALSE;
		return TRUE;
	}
	else {	// ۂɉ
		PushL1(pos0, len, push);
		PushL1(pos0 + 5, len, push);
	}

	return TRUE;
}
//****************************************************************
// Eɉ (len = ̈ړ, push = 0:̂ 1:)
//****************************************************************
int  PushR2(int pos0, int len, int  push);
// P}XŉEɉ
int  PushR1(int pos0, int len, int  push)
{
	int ok, pos1 = pos0 + 1;

	if (Rule2 == 0) {	// ̋Ȃ
		ok = BOARD[pos1] ? FALSE : TRUE;
	}
	else {				// ̋
		ok = FALSE;
		switch (BOARD[pos1]) {
		case  0: ok = TRUE; break;
		case 10: ok = PushR1(pos1, 1, push); break;
		case 20: ok = PushR2(pos1, 1, push); break;
		case 21: ok = PushR2(pos1 - 5, 1, push); break;
		case 30: ok = PushR1(pos1 + 1, 2, push); break;
		case 40: ok = PushR2(pos1 + 1, 2, push); break;
		case 42: ok = PushR2(pos1 - 4, 2, push); break;
		}
	}
	if (!ok) return FALSE;

	// ۂɉ
	if (push) Push(pos0, len, 1);

	return TRUE;
}
// Q}XŉEɉ
int  PushR2(int pos0, int len, int  push)
{
	int  pos1 = pos0 + 1;

	if (!push) {	// ̂
		if (!PushR1(pos0, len, push)) return FALSE;
		if (!PushR1(pos0 + 5, len, push)) return FALSE;
		return TRUE;
	}
	else {	// ۂɉ
		PushR1(pos0, len, push);
		PushR1(pos0 + 5, len, push);
	}

	return TRUE;
}
//****************************************************************
// [2~2]̈ړ
//****************************************************************
int  Move4(int pos0, cell* rptr)
{
	int  idx, plus;

	// ̔ՖʂstepsZl
	plus = (Rule1 == 0 || pos0 != rptr->hold) ? 1 : 0;

	// 
	if (PushU2(pos0, 2, FALSE)) {	// Ȃ
		idx = IDX;
		PushU2(pos0, 2, TRUE);		// 
		if (!Write(plus, pos0 - 5, rptr)) return FALSE;
		Back(idx);
	}

	// 
	if (PushD2(pos0 + 5, 2, FALSE)) {	// Ȃ
		idx = IDX;
		PushD2(pos0 + 5, 2, TRUE);		// 
		if (!Write(plus, pos0 + 5, rptr)) return FALSE;
		Back(idx);
	}

	// 
	if (PushL2(pos0, 2, FALSE)) {	// Ȃ
		idx = IDX;
		PushL2(pos0, 2, TRUE);		// 
		if (!Write(plus, pos0 - 1, rptr)) return FALSE;
		Back(idx);
	}

	// E
	if (PushR2(pos0 + 1, 2, FALSE)) {	// Ȃ
		idx = IDX;
		PushR2(pos0 + 1, 2, TRUE);		// 
		if (!Write(plus, pos0 + 1, rptr)) return FALSE;
		Back(idx);
	}

	return TRUE;
}
//****************************************************************
// []̈ړ
//****************************************************************
int  Move3(int pos0,cell * rptr)
{
	int  idx, plus;

	// ̔ՖʂstepsZl
	plus = (Rule1 == 0 || pos0 != rptr->hold) ? 1 : 0;

	// 
	if (PushU2(pos0, 1, FALSE)) {	// Ȃ
		idx = IDX;
		PushU2(pos0, 1, TRUE);		// 
		if (!Write(plus, pos0 - 5, rptr)) return FALSE;
		Back(idx);
	}

	// 
	if (PushD2(pos0, 1, FALSE)) {	// Ȃ
		idx = IDX;
		PushD2(pos0, 1, TRUE);		// 
		if (!Write(plus, pos0 + 5, rptr)) return FALSE;
		Back(idx);
	}

	// 
	if (PushL1(pos0, 2, FALSE)) {
		idx = IDX;
		PushL1(pos0, 2, TRUE);
		if (!Write(plus, pos0 - 1, rptr)) return FALSE;
		Back(idx);
	}

	// E
	if (PushR1(pos0 + 1, 2, FALSE)) {
		idx = IDX;
		PushR1(pos0 + 1, 2, TRUE);
		if (!Write(plus, pos0 + 1, rptr)) return FALSE;
		Back(idx);
	}

	return TRUE;
}
//****************************************************************
// [c]̈ړ
//****************************************************************
int  Move2(int pos0, cell* rptr)
{
	int  idx, plus;

	// ̔ՖʂstepsZl
	plus = (Rule1 == 0 || pos0 != rptr->hold) ? 1 : 0;

	// 
	if (PushU1(pos0, 2, FALSE)) {	// Ȃ
		idx = IDX;
		PushU1(pos0, 2, TRUE);		// 
		if (!Write(plus, pos0 - 5, rptr)) return FALSE;
		Back(idx);
	}

	// 
	if (PushD1(pos0 + 5, 2, FALSE)) {	// Ȃ
		idx = IDX;
		PushD1(pos0 + 5, 2, TRUE);		// 
		if (!Write(plus, pos0 + 5, rptr)) return FALSE;
		Back(idx);
	}

	// 
	if (PushL2(pos0, 1, FALSE)) {	// Ȃ
		idx = IDX;
		PushL2(pos0, 1, TRUE);		// 
		if (!Write(plus, pos0 - 1, rptr)) return FALSE;
		Back(idx);
	}

	// E
	if (PushR2(pos0, 1, FALSE)) {	// Ȃ
		idx = IDX;
		PushR2(pos0, 1, TRUE);		// 
		if (!Write(plus, pos0 + 1, rptr)) return FALSE;
		Back(idx);
	}

	return TRUE;
}
//****************************************************************
// [1~1]̈ړ
//****************************************************************
int  Move1(int pos0, cell* rptr)
{
	int  idx, plus;

	// ̔ՖʂstepsZl
	plus = (Rule1 == 0 || pos0 != rptr->hold)? 1 : 0;

	// 
	if (PushU1(pos0, 1, FALSE)) {	// Ȃ
		idx = IDX;
		PushU1(pos0, 1, TRUE);		// 
		if (!Write(plus, pos0 - 5, rptr)) return FALSE;
		Back(idx);
	}

	// 
	if (PushD1(pos0, 1, FALSE)) {	// Ȃ
		idx = IDX;
		PushD1(pos0, 1, TRUE);		// 
		if (!Write(plus, pos0 + 5, rptr)) return FALSE;
		Back(idx);
	}

	// 
	if (PushL1(pos0, 1, FALSE)) {	// Ȃ
		idx = IDX;
		PushL1(pos0, 1, TRUE);		// 
		if (!Write(plus, pos0 - 1, rptr)) return FALSE;
		Back(idx);
	}

	// E
	if (PushR1(pos0, 1, FALSE)) {	// Ȃ
		idx = IDX;
		PushR1(pos0, 1, TRUE);		// 
		if (!Write(plus, pos0 + 1, rptr)) return FALSE;
		Back(idx);
	}

	return TRUE;
}
//****************************************************************
// DT
//****************************************************************
int  Search(void)
{
	int  i;
	cell* rptr;

	// eՖʂǂ
	rptr = QUEUE[QIN][Qhead[QIN]++];
	if (rptr->steps >= MinSteps) return TRUE;

	// BOARD[]Č
	ListToBoard(BOARD, &(rptr->list[0]));

	// Ֆʂ̐ƕۑ
	for (i = C1S; i < C2S; i++)
		if (!Move1(rptr->list[i], rptr)) return FALSE;
	for (i = C2S; i < C3S; i++)
		if (!Move2(rptr->list[i], rptr)) return FALSE;
	for (i = C3S; i < C4S; i++)
		if (!Move3(rptr->list[i], rptr)) return FALSE;
	for (i = C4S; i < C4E; i++)
		if (!Move4(rptr->list[i], rptr)) return FALSE;

	return TRUE;
}
int  Solve(int  rule1, int rule2, int box[])
{
	int  i, pos, c0n, retc;

	// [
	Rule1 = rule1;
	Rule2 = rule2;

	// ě
	// box[] -> BOARD[]
	c0n = C1N = C2N = C3N = C4N = 0;
	for (i = 0; i < 20; i++) {
		switch (box[i]) {
		case  0: c0n++; break;
		case 10: C1N++; break;
		case 20: C2N++; break;
		case 30: C3N++; break;
		case 40: C4N++; break;
		}
		pos = INSIDE[i];
		BOARD[pos] = box[i];
	}
	if (c0n < 2 && BOARD[21] != 40) return TRUE;	// Ȃ

	// e̋L^Jnʒu
	C1S = 0;
	C2S = C1N;
	C3S = C1N + C2N;
	C4S = C1N + C2N + C3N;
	C4E = C1N + C2N + C3N + C4N;

	// 
	for (i = 0; i < HASH_SIZE; i++)
		BUCKET[i].steps = -1;
	BucketCnt = ThreadBreak = 0;
	Qhead[0] = Qtail[0] = Qhead[1] = Qtail[1] = 0;
	QIN = 0;
	QOUT = 1;
	FindPtr = NULL;
	MinSteps = 999;

	// zuo^
	retc = Write(0, 0, NULL);
	StartPtr = QUEUE[QIN][0];
	if (FindPtr) return SOLVED;	// ŏ犮

	// DTs
	while (Qhead[QIN] < Qtail[QIN]) {
		while (Qhead[QIN] < Qtail[QIN]) {
			if (ThreadBreak) return CANCEL;	// WndowsŐp
			if (!Search()) return FALSE;	// CELLs
		}
		// QUEUE[]̗
		QIN ^= 1;
		QOUT ^= 1;
	}

	// g[Xf[^쐬
	if (FindPtr) {
		Trace(FindPtr, NULL, NULL, 0);
		return SOLVED;	// 𔭌
	}

	return TRUE;	// 𖳂
}
