//****************************************************************
// Klotski Console V1.0 by takaken
//****************************************************************
#include <stdio.h>
#include <stdlib.h>

#define  FALSE	  0	// CELLs
#define  TRUE	  1	// I

// \o[
#include "hako10solver.c"

//****************************************************************
// ʂ\
//****************************************************************
void Result(int retc, int map[])
{
	int  i, hold, steps;
	cell* ptr;
	char char1[5][2] = {
		" ","*", "|", "-", "@"
	};
	char char2[29][3] = {
		"","","","","",
		"A1","B1","C1","D1","",
		"A2","B2","C2","D2","",
		"A3","B3","C3","D3","",
		"A4","B4","C4","D4","",
		"A5","B5","C5","D5"
	};

	// }
	for (i = 0; i < 20; i++) {
		printf("%s", char1[map[i] / 10]);
		if ((i + 1) % 4 == 0) printf("\n");
	}

	// [
	printf("Rule: %s,%s\n", Rule1 ? "Yes" : "No", Rule2 ? "Yes" : "No");

	// CELLs
	if (retc == FALSE) {
		printf("Cells overflow.\n");
		return;
	}

	// 
	if (retc == TRUE) {
		printf("Unsolvable.\n");
		return;
	}

	// 𔭌
	printf("Optimal: %d Steps.\nSolution:", MinSteps);
	hold = steps = 0;
	for (ptr = StartPtr; ptr != FindPtr; ptr = ptr->next) {
		if (Rule1 == 0 || ptr->hold != hold) {
			printf("\n%3d: %s %s", ++steps, char2[ptr->hold], char2[ptr->steps]);
		}
		else {
			printf(" %s", char2[ptr->steps]);
		}
		hold = ptr->steps;
	}
	printf("\n");
}
//****************************************************************
// Gg[|Cg
//****************************************************************
int main(void)
{
	int  retc;

	// [m
	if (!MemAlloc()) {
		printf("Out of memory.");
		return 0;
	}

	// o`
	int  rule1 = 1;		// 0[Aړs]	1[Aړ\]
	int  rule2 = 1;		// 0[s]	1[\]
	int  box[20] = {	// }
		20,40,41,20,
		21,42,43,21,
		20,30,31,20,
		21,10,10,21,
		10, 0, 0,10
	};

	// T
	retc = Solve(rule1, rule2, box);

	// ʕ\
	Result(retc, box);
	printf("Cells = %d\n", BucketCnt);

	// [
	MemFree();

	return 0;
}
